

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #GSignalInvocationHint structure is used to pass on additional information
to callbacks during a signal emission.
-}

module GI.GObject.Structs.SignalInvocationHint
    ( 

-- * Exported types
    SignalInvocationHint(..)                ,
    newZeroSignalInvocationHint             ,
    noSignalInvocationHint                  ,


 -- * Properties
-- ** Detail
    signalInvocationHintReadDetail          ,


-- ** RunType
    signalInvocationHintReadRunType         ,


-- ** SignalId
    signalInvocationHintReadSignalId        ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.GObject.Types
import GI.GObject.Callbacks

newtype SignalInvocationHint = SignalInvocationHint (ForeignPtr SignalInvocationHint)
-- | Construct a `SignalInvocationHint` struct initialized to zero.
newZeroSignalInvocationHint :: MonadIO m => m SignalInvocationHint
newZeroSignalInvocationHint = liftIO $ callocBytes 12 >>= wrapPtr SignalInvocationHint

noSignalInvocationHint :: Maybe SignalInvocationHint
noSignalInvocationHint = Nothing

signalInvocationHintReadSignalId :: SignalInvocationHint -> IO Word32
signalInvocationHintReadSignalId s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO Word32
    return val

signalInvocationHintReadDetail :: SignalInvocationHint -> IO Word32
signalInvocationHintReadDetail s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 4) :: IO Word32
    return val

signalInvocationHintReadRunType :: SignalInvocationHint -> IO [SignalFlags]
signalInvocationHintReadRunType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CUInt
    let val' = wordToGFlags val
    return val'

type family ResolveSignalInvocationHintMethod (t :: Symbol) (o :: *) :: * where
    ResolveSignalInvocationHintMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveSignalInvocationHintMethod t SignalInvocationHint, MethodInfo info SignalInvocationHint p) => IsLabelProxy t (SignalInvocationHint -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveSignalInvocationHintMethod t SignalInvocationHint, MethodInfo info SignalInvocationHint p) => IsLabel t (SignalInvocationHint -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


