

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

A structure that provides information to the type system which is
used specifically for managing fundamental types.
-}

module GI.GObject.Structs.TypeFundamentalInfo
    ( 

-- * Exported types
    TypeFundamentalInfo(..)                 ,
    newZeroTypeFundamentalInfo              ,
    noTypeFundamentalInfo                   ,


 -- * Properties
-- ** TypeFlags
    typeFundamentalInfoReadTypeFlags        ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.GObject.Types
import GI.GObject.Callbacks

newtype TypeFundamentalInfo = TypeFundamentalInfo (ForeignPtr TypeFundamentalInfo)
-- | Construct a `TypeFundamentalInfo` struct initialized to zero.
newZeroTypeFundamentalInfo :: MonadIO m => m TypeFundamentalInfo
newZeroTypeFundamentalInfo = liftIO $ callocBytes 4 >>= wrapPtr TypeFundamentalInfo

noTypeFundamentalInfo :: Maybe TypeFundamentalInfo
noTypeFundamentalInfo = Nothing

typeFundamentalInfoReadTypeFlags :: TypeFundamentalInfo -> IO [TypeFundamentalFlags]
typeFundamentalInfoReadTypeFlags s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = wordToGFlags val
    return val'

type family ResolveTypeFundamentalInfoMethod (t :: Symbol) (o :: *) :: * where
    ResolveTypeFundamentalInfoMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveTypeFundamentalInfoMethod t TypeFundamentalInfo, MethodInfo info TypeFundamentalInfo p) => IsLabelProxy t (TypeFundamentalInfo -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveTypeFundamentalInfoMethod t TypeFundamentalInfo, MethodInfo info TypeFundamentalInfo p) => IsLabel t (TypeFundamentalInfo -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


